"""
The :mod:`revrand.optimize` module provides a standardized interface to
popular optimization libraries and tools, such as NLopt and ``scipy.optimize``,
and also supports custom optimization methods.
"""

from .sgd import sgd, AdaDelta, AdaGrad, Momentum, SGDUpdater
from .base import (minimize_bounded_start,
                   structured_minimizer,
                   structured_sgd,
                   logtrick_minimizer,
                   logtrick_sgd,
                   candidate_start_points_lattice,
                   candidate_start_points_random)

__all__ = [
    'sgd',
    'AdaDelta',
    'AdaGrad',
    'Momentum',
    'SGDUpdater',
    'minimize_bounded_start',
    'structured_minimizer',
    'structured_sgd',
    'logtrick_minimizer',
    'logtrick_sgd',
    'candidate_start_points_lattice',
    'candidate_start_points_random',
]
